/* eslint-disable prefer-const */
/* eslint-disable dot-notation */
/* eslint-disable no-unused-vars */
/* eslint-disable eqeqeq */
/* eslint-disable camelcase */
/* eslint-disable no-lone-blocks */
// We require the Hardhat Runtime Environment explicitly here. This is optional
// but useful for running the script in a standalone fashion through `node <script>`.
//
// When running the script with `npx hardhat run <script>` you'll find the Hardhat
// Runtime Environment's members available in the global scope.

const { ContractFactory } = require("ethers");
const hre = require("hardhat");

const upgradeAbleContracts = [
    {addr: "0x452B05527F70bE30e16D01610C57E40c8ced54C6",  name:"UserLogin", path:"UserLoginContract"},
    {addr: "0xD5e6035CE7371d0C0664A4d152788D8411F71fe7",  name:"Constant", path:"Constant"},
    {addr: "0xa849f84Bf38175D618d3495310672E5DFfFd6D24",  name:"Coin", path:"Coin"},
    {addr: "0x92dC3A31960E920f00B526bEc4594CCF13D244BF",  name:"Coin721", path:"Coin721"},
    // {addr: "0xefB856A4A8fA069F60a41a2237a1eA4482FE7d4d",  name:"NFTMysteryBoxOffering", path:"NFTMysteryBoxOffering"},
    // {addr: "0xfd441677247Dd2961Bba8F46b4bb3D6598E172A3",  name:"Random", path:"Random"},
    // {addr: "0xE32902791FCC89047465392600af7CF08073DdA5",  name:"Whitelist", path:"Whitelist"},
    // {addr: "0xD9e4fAa4C31694FcdFcfa2eDE8C3Ae7D25F28AB6",  name:"MysteryBox", path:"MysteryBox"},
    // {addr: "0xb6b8A39137958B8DCd3A34E24A2E44787bc22bAF",  name:"MysteryData", path:"MysteryData"},
    // {addr: "0x196e5719F7983F8749A23B5142f7308f4196f6C3",  name:"RaceBonusDistribute", path:"RaceBonusDistribute"},
    // {addr: "0x6e0bBb19021E290eCA0366D14c9FcC66DB1E15f2",  name:"RaceBonusPool", path:"RaceBonusPool"},
    // {addr: "0x4f99c25aCA0d56Cf2E8E36D7e83C9a4329c5FB01",  name:"RaceBonusData", path:"RaceBonusData"},
    {addr: "0xeE60AB31Da5f991D89D8918e2c1a784EEDe41f7f",  name:"RaceNFTAttr", path:"ERC721Attr"},
    {addr: "0x897aF09d81d347BC4940E58157B672EdBC7Fa3Dd",  name:"EquipAttr", path:"HorseEquipAttrOperaContract"},
    {addr: "0xe40B9C2CAC590a45e666545862aA59a050f5C498",  name:"ArenaAttr", path:"HorseArenaAttrOperaContract"},
    {addr: "0x2bA3BD1bE12a696A5da58EF434d0Fa47B2bE4F5D",  name:"RaceAttr1", path:"HorseRaceAttrOpera1"},
    {addr: "0x7Fe9395130Db10cB7B1c547632602F6d5608d72b",  name:"RaceAttr1_1", path:"HorseRaceAttrOpera1_1"},
    {addr: "0x2d15B840CE5De85931d915003af44B29a78ae16D",  name:"RaceAttr2", path:"HorseRaceAttrOpera2"},
    {addr: "0xC7B7b222cB8E12EF1B73123732b3aFA94FE5b835",  name:"RaceAttr2_1", path:"HorseRaceAttrOpera2_1"},
    {addr: "0x147612b0E32B7Be28C32375A85B98A6b0FaF8d34",  name:"HorseCourseAttr", path:"ERC721Attr"},
    {addr: "0xC8574F717bc5C5A9B029eAd3Da669E745E101542",  name:"HorseCourseAttrOpera", path:"RacecourseAttrOperaContract"},
    {addr: "0x3BCC634C43c15971623d5E33475b1732553440b9",  name:"EquipExtra", path:"HorseEquipContract"},
    {addr: "0x6bE51BD56aabAC86A8b0E62F7e23f2Aa49Bc92ac",  name:"RaceExtra", path:"HorseRaceContract"},
    {addr: "0x1C961B7373a5cF966F45Ab9Ad493C405943b3e3a",  name:"RaceExtra1", path:"HorseRaceExtra1"},
    {addr: "0xdb6e69467083fbe6AAE0dff0823353Ce82c8c35f",  name:"RaceExtra2", path:"HorseRaceExtra2"},
    {addr: "0x83c812Cd6e4ea911a9628bcDEBc48c079C92dC68",  name:"ArenaExtra", path:"HorseArenaContract"},
    {addr: "0xd1933659411d0Fe803f6eC24F6b47627210C5Db0",  name:"ArenaExtra1", path:"HorseArenaExtra"},
    {addr: "0x5A952fbb82E3c1238d9692126A77002675A1D80f",  name:"ArenaExtra2", path:"HorseArenaExtra2"},
    {addr: "0x82a947F3D70C86E8Fc01d70414650fA29d9578d4",  name:"ArenaExtra3", path:"HorseArenaExtra3"}
]

let ContractMap = new Map();


async function getContract(contractPath, address) {
    return await hre.ethers.getContractAt(contractPath, address);
}

async function upgradeContract(proxyAddress, contractName, contractPath) {
    const newContract = await ethers.getContractFactory(contractPath);
    console.log("upgrade " + contractPath + " to " + proxyAddress);
    const nContract = await upgrades.upgradeProxy(proxyAddress, newContract);
    await nContract.waitForDeployment();
    const nAddress = await nContract.getAddress();
    console.log(contractName + " deploy at:", nAddress);
}



async function upgradeAllContracts() {
    for (let i = 0; i < upgradeAbleContracts.length; i++) {
        const contract = upgradeAbleContracts[i];
        const addr = contract.addr;
        const name = contract.name;
        const path = contract.path;
        var newPath = path + "V2";
        await upgradeContract(addr, name, newPath);
    }

    for (let i = 0; i < upgradeAbleContracts.length; i++) {
        const contract = upgradeAbleContracts[i];
        const addr = contract.addr;
        const name = contract.name;
        const path = contract.path;
        var newPath = path + "V2";
        const contractObj = await getContract(newPath, addr);
        const version = await contractObj.getUpgradeInfo();
        console.log("contract ", name, " version is ", version);
    }
}

async function main() {
    await upgradeAllContracts();
}

// We recommend this pattern to be able to use async/await everywhere
// and properly handle errors.
main().catch((error) => {
    console.error(error);
    process.exitCode = 1;
});
